
Core - Task # 57104

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Epic # 55656 (Accepted): Optimize overall Extbase performance
Story # 55168 (Accepted): Optimize Extbase generic persistence
Task # 55167 (Resolved): Extbase: avoid parseQuery() / buildQuery() to be called multiple times

Status: Resolved Priority: Must have
Author: Alexander Stehlik Category: Extbase
Created: 2014-03-20 Assigned To:
Updated: 2014-03-24 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Sprint Focus:
Subject: Regression: Query building fails for LazyObjectStorage
Description

When a LazyObjectStorage is used in an "in" comparison you get a PHP error:

Object of class TYPO3\CMS\Extbase\Persistence\Generic\LazyObjectStorage could not be converted to string in
typo3/sysext/extbase/Classes/Persistence/Generic/Storage/Typo3DbBackend.php line 542

I guess this is also a regression of #55167

Associated revisions
Revision ff162d36 - 2014-03-24 21:46 - Marc Bastian Heinrichs

[BUGFIX] Fix operator "in" for cached queries

This a follow up fix for the extbase query cache. On reusing an already
build query, it was missed to evaluate the multi valued operator and
provide it as array for resolving the parameter placeholders.

Resolves: #57104
Releases: 6.2
Change-Id: I06abbf5279ee05382a7ba314948f7d3f075d84e6
Reviewed-on: https://review.typo3.org/28695
Reviewed-by: Alexander Stehlik
Tested-by: Alexander Stehlik
Tested-by: Wouter Wolters
Reviewed-by: Felix Oertel
Tested-by: Felix Oertel

History
#1 - 2014-03-20 18:26 - Markus Klein
- Project changed from Extbase MVC Framework to Core
- Category deleted (Extbase: Generic Persistence)
#2 - 2014-03-20 18:26 - Markus Klein
- Category set to Extbase
- Priority changed from Should have to Must have
- Target version set to next-patchlevel
- Is Regression set to Yes
- TYPO3 Version set to 6.2

#3 - 2014-03-20 18:50 - Marc Bastian Heinrichs

And what does happen, if it is a normal object storage? From reading the code it should also fail.

#4 - 2014-03-20 18:52 - Alexander Stehlik

I think it does but I'm not sure. Started digging but did not find the right spot yet :(

#5 - 2014-03-20 18:56 - Marc Bastian Heinrichs

see comments in https://review.typo3.org/#/c/27555/12/typo3/sysext/extbase/Classes/Persistence/Generic/Storage/Typo3DbBackend.php

#6 - 2014-03-20 19:01 - Alexander Stehlik

Oh, than it was that spot. I have already looked at it but i was not sure.

I'll push my first WIP patch in a minute.

#7 - 2014-03-20 19:04 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#8 - 2014-03-20 22:13 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#9 - 2014-03-21 00:30 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#10 - 2014-03-21 03:01 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576
#11 - 2014-03-21 03:08 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#12 - 2014-03-21 13:35 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#13 - 2014-03-21 14:11 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#14 - 2014-03-21 17:30 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#15 - 2014-03-22 20:59 - Ernesto Baschny
- Parent task set to #55167

#16 - 2014-03-22 21:00 - Ernesto Baschny
- Target version changed from next-patchlevel to 6.2.0

#17 - 2014-03-24 11:36 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#18 - 2014-03-24 12:11 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28695

#19 - 2014-03-24 14:22 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28695

#20 - 2014-03-24 14:44 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28695
#21 - 2014-03-24 19:05 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28695

#22 - 2014-03-24 20:17 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28695

#23 - 2014-03-24 20:20 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#24 - 2014-03-24 20:37 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28576

#25 - 2014-03-24 22:30 - Marc Bastian Heinrichs
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ff162d3650c4a2069908448d67d67ea37f490ac9.
